import six
from ipywidgets import (
    Widget, DOMWidget, widget_serialization, register
)
from ipywidgets.widgets.trait_types import TypedTuple
from traitlets import (
    Unicode, Int, CInt, Instance, ForwardDeclaredInstance, This, Enum,
    Tuple, List, Dict, Float, CFloat, Bool, Union, Any,
)

from .._base.Three import ThreeWidget
from .._base.uniforms import uniforms_serialization
from ..enums import *
from ..traits import *

from .Texture_autogen import Texture


@register
class CompressedTexture(Texture):
    """CompressedTexture

    Autogenerated by generate-wrappers.js
    See https://threejs.org/docs/#api/textures/CompressedTexture
    """

    def __init__(self, **kwargs):
        super(CompressedTexture, self).__init__(**kwargs)

    _model_name = Unicode('CompressedTextureModel').tag(sync=True)


if six.PY3:
    import inspect
    # Include explicit signature since the metaclass screws it up
    CompressedTexture.__signature__ = inspect.signature(CompressedTexture.__init__)
